-- Battleground Sounds
-- By Delthis of Kil'Jaeden
--
-- Thanks to Ratchet of KJ for sample code found in dgks
--
-- Adds helpful/fun sounds to battlegrounds
-- 
-- Access help with '/bgs'
--
-- PLEASE REPORT BUGS TO x3haloed@gmail.com
--
--Changelog:
--20300.01 (alpha)	First version



-- Some vars to edit. First var in array is sound length in seconds, second var is file name, and third is place in queue.
--Alliance messages
B_FLAG_DROPPED = {2, "Interface\\AddOns\\bgsounds\\sounds\\bflagdropped.wav"};
R_FLAG_TAKEN = {2, "Interface\\AddOns\\bgsounds\\sounds\\rflagtaken.wav"};
B_TEAM_SCORES = {3, "Interface\\AddOns\\bgsounds\\sounds\\bteamscores.wav"};
B_FLAG_RETURNED = {2, "Interface\\AddOns\\bgsounds\\sounds\\bflagreturned.wav"};


--Horde messages
R_FLAG_DROPPED = {2, "Interface\\AddOns\\bgsounds\\sounds\\rflagdropped.wav"};
B_FLAG_TAKEN = {2, "Interface\\AddOns\\bgsounds\\sounds\\bflagtaken.wav"};
R_TEAM_SCORES = {3, "Interface\\AddOns\\bgsounds\\sounds\\rteamscores.wav"};
R_FLAG_RETURNED = {2, "Interface\\AddOns\\bgsounds\\sounds\\rflagreturned.wav"};

--Chat msg system messages
B_TEAM_WINS = {3, "Interface\\AddOns\\bgsounds\\sounds\\bteamwins.wav"};
R_TEAM_WINS = {3, "Interface\\AddOns\\bgsounds\\sounds\\rteamwins.wav"};

NEW_ROUND_IN = {2, "Interface\\AddOns\\bgsounds\\sounds\\newroundin.wav"};
THREE = {1, "Interface\\AddOns\\bgsounds\\sounds\\three.wav"};
TWO = {1, "Interface\\AddOns\\bgsounds\\sounds\\two.wav"};
ONE = {1, "Interface\\AddOns\\bgsounds\\sounds\\one.wav"};

--Voice communincation sounds
--ATTACK = {1, "Interface\\AddOns\\bgsounds\\sounds\\robot\\attack_their_base.wav"};

--Sound queue related stuff, shouldn't need to change
--Many of these are useless and need to be cleaned up
filesInQueue = 0;
currentSoundQueue = 0;
queueTable = {};
queueActive = 0;
soundPlaying = 0;
playStop = 0;
newRoundIn = 0;
inBG = nil;



local options = { 
	type='group',
	args = {
		test = {
			type = 'execute',
			name = 'Test bgs',
			desc = 'Test bgs sound',
			func = "bgs_test"
		}--,
		--say = {
		--	type = 'text',
		--	name = 'Say',
		--	desc = 'Say something to your team',
		--	set = "bgs_say",
		--	get = "bgs_say_get",
		--	usage = "<what you want to say>"
		--}--,
		--wsgupdate = {
		--	type = 'execute',
		--	name = 'WSG Update',
		--	desc = 'Update WSG info',
		--	func = "update_wsg"
		--}		
	}
};

bgs = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0");
bgs:RegisterChatCommand("/bgsounds", "/bgs", options);


function bgs:OnEnable()
	-- Called when the addon is enabled
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	if (GetZoneText() == "Warsong Gulch") then
		bgs:wsg_battle();
--	elseif (GetZoneText() == "Eye of the Storm") then
--		bgs:eots_battle();
--	elseif (GetZoneText() == "Arathi Basin") then
--		bgs:ab_battle();
--	elseif (GetZoneText() == "Alterac Valley") then
--		bgs:av_battle();
	end
end

function bgs:ZONE_CHANGED_NEW_AREA()

	local newzone = GetZoneText();

	if (newzone == "Warsong Gulch") then
		bgs:wsg_battle();
	else
		if (inBG ~= nil) then
			bgs:exit_bg();
		end
	end
end
	
function bgs:OnUpdate(arg1)
--	testvar = arg1;
--	if (inBG ~= nil) then	
		if ((playStop ~= 0) and (GetTime() >= playStop)) then
--			soundPlaying = 0;
			bgs:sound_queue(0);
		end
		if ((newRoundIn ~= 0) and (GetTime() >= newRoundIn)) then
			bgs:new_round();
		end
--	end
end


--function bgs:bgs_PlaySoundFile(arg1)
--		PlaySoundFile(arg1);
--		if not (PlaySoundFile(arg1)) then
--			self:ScheduleEvent("bgs_PlaySoundFile", 0.2	, arg1);
--		end
--end

function bgs:bgs_test()
	bgs:sound_queue(NEW_ROUND_IN);
end

function bgs:exit_bg()
	inBG = nil;
	self:UnregisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	self:UnregisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
	self:UnregisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
end

function bgs:wsg_battle()
	bgs:Print("WSG battle sounds ready.");
	inBG = "Warsong Gulch";
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
end

--function bgs:eots_battle()
--	inBG = "Eye of the Storm";
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
--end

--function bgs:ab_battle()
--	inBG = "Arathi Basin";
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
--end

--function bgs:av_battle()
--	inBG = "Alterac Valley";
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
--	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
--end

--function bgs:update_wsg()
--	if text:find("Alliance") then
--		PlaySoundFile("Interface\\AddOns\\bgsounds\\sounds\\bflagdropped.wav");
--	end
--end

function bgs:CHAT_MSG_BG_SYSTEM_ALLIANCE(msg)
--	if (inBG == "Warsong Gulch") then
		if (string.find (msg, "dropped") ~= nil) then
			bgs:sound_queue(B_FLAG_DROPPED);
		elseif (string.find (msg, "picked") ~= nil) then
			bgs:sound_queue(R_FLAG_TAKEN);
		elseif (string.find (msg, "captured") ~= nil) then
			bgs:sound_queue(B_TEAM_SCORES);
			newRoundIn = GetTime() + 16;
		elseif (string.find (msg, "returned") ~= nil) then
			bgs:sound_queue(B_FLAG_RETURNED);
		else
			message("Alliance");
		end
--	end
end

function bgs:CHAT_MSG_BG_SYSTEM_HORDE(msg)
--	if (inBG == "Warsong Gulch") then
		if (string.find (msg, "dropped") ~= nil) then
			bgs:sound_queue(R_FLAG_DROPPED);
		elseif (string.find (msg, "picked") ~= nil) then
			bgs:sound_queue(B_FLAG_TAKEN);
		elseif (string.find (msg, "captured") ~= nil) then
			bgs:sound_queue(R_TEAM_SCORES);
			newRoundIn = GetTime() + 16;
		elseif (string.find (msg, "returned") ~= nil) then
			bgs:sound_queue(R_FLAG_RETURNED);
		else
			message("Horde");
		end
--	end
end

function bgs:CHAT_MSG_BG_SYSTEM_NEUTRAL(msg)
--	if (inBG == "Warsong Gulch") then
		if (string.find (msg, "seconds") ~= nil) then
		newRoundIn = GetTime() + 24;
		end
		
		if (string.find (msg, "Horde") ~= nil) then
			newRoundIn = 0;
			bgs:sound_queue(R_TEAM_WINS);
		end
		
		if (string.find (msg, "Alliance") ~= nil) then
			newRoundIn = 0;
			bgs:sound_queue(B_TEAM_WINS);
		end
--	end
end

function bgs:new_round()
	newRoundIn = 0;
	bgs:sound_queue(NEW_ROUND_IN);
	bgs:sound_queue(THREE);
	bgs:sound_queue(TWO);
	bgs:sound_queue(ONE);
end

--function bgs:bgs_say(msg)
--	if (msg == nil) then
--		bgs:Print("Options are as follows:");
--		bgs:Print("attack");
--	elseif (msg == "attack") then
--		bgs:Print("Attack their base!");
--		bgs:sound_queue(ATTACK);
--	end
--end

--function bgs:bgs_say_get(msg)
--	return "say";
--end




function bgs:sound_queue(sound)
	local currentTime = GetTime();
	if (sound ~= 0) then
		currentspot = 0;
		spotnum = 0;
		while currentspot ~= nil do
			currentspot = queueTable[spotnum + 1];
			spotnum = spotnum + 1;
		end
		queueTable[spotnum] = sound[1];
		queueTable[spotnum + 1] = sound[2];
		queueActive = 1;
	end
	
	if (soundPlaying == 1) then
		if (GetTime() >= playStop) then
			soundPlaying = 0;
			playStop = 0;
		end
	end
	
	if (queueTable[1] ~= nil) then
		if (soundPlaying == 0) then
			PlaySoundFile(queueTable[2]);
			playStop = GetTime() + queueTable[1];
			soundPlaying = 1;
			currentspot = 0;
			spotnum = 0;
			while currentspot ~= nil do
				currentspot = queueTable[spotnum + 1];
				spotnum = spotnum + 1;
			end
--			if (spotnum >= 4) then
				for i = 3, spotnum do
					queueTable[i - 2] = queueTable[i];
				end
--			end
			queueTable[spotnum] = nil;
			queueTable[spotnum -1] = nil;
		end
	end
	
	
		
	

end